config/routes.rb
Rails.application.routes.draw do
  root "movies#index"

  get "/movies", to: "movies#index"
  get "/movies/search", to: "movies#search"
  get "/movies/releases", to: "movies#releases"
  get "/movies/top10", to: "movies#top10"
  get "/movies/genders/:id", to: "movies#genders"
  
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
    def index
    end   
end

app/controllers/concerns/movies.rb
module Movies
    extend ActiveSupport::Concern

    def self.utils_service(url)
        @service = HTTParty.get(url)
        @hash = JSON.parse(@service.body)
    end    
end  

app/controllers/movies_controller.rb
class MoviesController < ApplicationController

  def index
    url = "#{ENV['BASE_URL']}#{ENV['API_URL']}#{ENV['API_KEY']}"
    @movies_hash = Movies.utils_service(url)
    @movies = @movies_hash.select{|m| m['results']}['results']
  end

  def search
    url = "#{ENV['BASE_URL']}#{ENV['SEARCH_URL']}#{ENV['API_KEY']}&query=#{params[:movie]}"
    @movies_hash = Movies.utils_service(url)
    @movies = @movies_hash.select{|m| m['results']}['results']
    render "index"
  end

  def releases
    url = "#{ENV['BASE_URL']}#{ENV['RELEASES_URL']}#{ENV['API_KEY']}&language=en-US"
    @movies_hash = Movies.utils_service(url)
    @movies = @movies_hash.select{|m| m['results']}['results']
    render "index"
  end
  
  def top10
    url = "#{ENV['BASE_URL']}#{ENV['TOP10_URL']}#{ENV['API_KEY']}&language=en-US&page=1"
    @movies_hash = Movies.utils_service(url)
    @movies = @movies_hash.select{|m| m['results']}['results']
    render "index"
  end

  def genders
    url = "#{ENV['BASE_URL']}#{ENV['API_URL']}#{ENV['API_KEY']}&with_genres=#{params[:id]}"
    @movies_hash = Movies.utils_service(url)
    @movies = @movies_hash.select{|m| m['results']}['results']
    render "index"
  end
  
end

app/helpers/application_helper.rb
module ApplicationHelper

    def genres
        url = "#{ENV['BASE_URL']}#{ENV['GENRES_URL']}#{ENV['API_KEY']}&language=pt-BR"
        @genres_hash = Movies.utils_service(url)
        @genres = @genres_hash.select{|m| m['genres']}['genres']
    end    
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/films_helper.rb
module FilmsHelper
end

app/helpers/releases_helper.rb
module ReleasesHelper
end

app/helpers/search_helper.rb
module SearchHelper
end

app/helpers/series_helper.rb
module SeriesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <script src="https://code.jquery.com/jquery-3.6.0.js"></script>
    <link rel="stylesheet" href="/assets/style.css">
    <title>Best Movies</title>
    <link rel="icon" type="image/x-icon" href="favicon2.ico"/>
  
</head>
<body>
    <header>
        <div class="image">
            <%= image_tag("favicon1.png", :alt => "rss feed", width:'150px') %>
        </div>
        <div class="card">

            <button>
                <%= link_to movies_releases_url, type:"button", class:"decoratinone" do %>Lançamentos
                    <%= fa_icon "rocket" %>
                <% end %>
            </button>

            <button>
                <%= link_to movies_top10_url, type:"button", class:"decoratinone" do %>Top 10 
                    <%= fa_icon "star" %>
                <% end %>
            </button>

            <% movie = params[:movie].present? ? params[:movie] : "" %>
            <%= text_field_tag :movie, "", class:"form-control", 
                placeholder: "Digite um nome de um filme", id: "movie_search", value: movie %>
            <button type="submit" class="btn btn-primary" id="btn_search" data-icon="search">
                <%= fa_icon "search" %>
            </button>     
        </div>
 
    </header>

    <div id="tags">
        <%= render partial: "/movies/genres" %>
    </div>

    <div id="myNav" class="overlay">
        <!-- Button to close the overlay navigation -->
        <a href="javascript:void(0)" class="closebtn" onclick="closeNav()">&times;</a>
        <!-- Overlay content -->
        <div class="overlay-content" id="overlay-content"></div>
        <a href="javascript:void(0)" class="arrow left-arrow" id="left-arrow">&#8656;</a> 
        <a href="javascript:void(0)" class="arrow right-arrow" id="right-arrow" >&#8658;</a>
    </div>

    <main id="main">
        <%= yield %>
    </main>

</body>
</html>

<script>
    $("#btn_search").click(function(){
        $.ajax({
            type:'GET',
            dataType:'JSON',
            url:'/movies/search',
            data: {
                'movie': $('#movie_search').val(),
                authenticity_token: $('[name="csrf-token"]')[0].content
            },
            success: function() {   
                location.reload();  
            },
            error: function (data) {
                window.location.replace("http://"+"<%= request.host_with_port %>"+"/movies/search?movie="+ $('#movie_search').val() + "&authenticity_token="+$('[name="csrf-token"]')[0].content);
            }
        });
    });
</script>

app/views/movies/_genres.html.erb
<% genres.each do |genre| %>
    <button class="tag">
      <%= link_to genre['name'], "/movies/genders/#{genre['id']}", value: genre['id'], class:"decoratinone"%>
    </button>
<% end %>

app/views/movies/_modal_form.html.erb
<!-- Button trigger modal -->
<button type="button" class="btn btn-primary namemodal" data-bs-toggle="modal" data-bs-target="#exampleModal">
  Ver
</button>

<!-- Modal -->
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="exampleModalLabel"><%= title %></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <%= overview %>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary">Save changes</button>
      </div>
    </div>
  </div>
</div>

app/views/movies/_movies.html.erb
<%= render partial: "result" %>

app/views/movies/_result.html.erb
<% if @movies.present? %>
    <% @movies.each do |movie| %>
        <div class="movie">
            <div>
                <% url_image = movie['backdrop_path'].present? ? "#{ENV['IMG_URL']}#{movie['backdrop_path']}" : '/assets/generic.png'%>
                <%= image_tag url_image, alt:"#{movie['original_title']}" %>
                <div class="movie-info">
                    <h3 class="textfont"><%= movie['original_title'] %></h3>
                    <span class="green"><%= movie['vote_average'] %></span>
                </div>
                <div>
                <%= render "/movies/modal_form", 
                    overview: movie['overview'], title: movie['original_title'],
                    image_url: url_image %>
                </div>
            </div>
        </div>
        
    <% end %>


<% else %>    
    <div class="alert alert-warning" role="alert">
        Favor informar um filme para busca.
    </div>
    
<% end %>


app/views/movies/index.html.erb
<%= render partial: "result" %>